package de.guidemo;

import com.vaadin.data.util.BeanItem;
import com.vaadin.event.ShortcutAction.KeyCode;
import com.vaadin.incubator.dashlayout.ui.HorDashLayout;
import com.vaadin.incubator.dashlayout.ui.VerDashLayout;
import com.vaadin.terminal.Sizeable;
import com.vaadin.ui.Alignment;
import com.vaadin.ui.Button;
import com.vaadin.ui.Form;
import com.vaadin.ui.Label;
import com.vaadin.ui.Panel;
import java.util.Arrays;

public class LoginPanel extends Panel 
{
  private static final String FIELD_USERNAME = "userName";
  private static final String FIELD_PASSWORD = "password";
  private VerDashLayout mainVL;
  private Panel mainPnl;
  private VerDashLayout panelVL;
  // change the following line to: private VerticalLayout innerVL2;
  private VerDashLayout innerVL2;
  private VerDashLayout innerVL;
  private Label anmeldungLbl;
  private HorDashLayout buttonLO;
  private Button loginBtn;
  private Button closeBtn;
  private LoginBean loginBean;
  private final Form loginForm = new Form();

  public LoginPanel()
  {
    super();
    setCaption(null);
  }

  public void doInit()
  {
    setSizeFull();

    loginBean = new LoginBean();
    BeanItem<LoginBean> loginItem = new BeanItem<LoginBean>(loginBean);
    loginForm.setWidth("80%");
    loginForm.setWriteThrough(false);
    loginForm.setInvalidCommitted(false);
    loginForm.setItemDataSource(loginItem);
    loginForm.setVisibleItemProperties(Arrays.asList(new String[]
            {
              FIELD_USERNAME, FIELD_PASSWORD
            }));

    mainVL = new VerDashLayout();
    mainVL.setHeight("100%");
    mainVL.setMargin(false);
    mainVL.addStyleName("bg-standard");
    panelVL = new VerDashLayout();
    panelVL.setSizeFull();
    mainPnl = new Panel();
    mainPnl.setHeight("80%");
    mainPnl.setWidth("80%");
    mainPnl.addStyleName("bg-grey2");

    // change the following line to: innerVL2 = new VerticalLayout();
    innerVL2 = new VerDashLayout();
    innerVL2.setSizeFull();

    innerVL = new VerDashLayout();
    innerVL.setWidth("450px");
    innerVL.setHeight("250px");
    anmeldungLbl = new Label("login");
    anmeldungLbl.setWidth(100f, Sizeable.UNITS_PERCENTAGE);
    anmeldungLbl.addStyleName("bb");
    anmeldungLbl.addStyleName("fs-18");
    innerVL.addComponent(anmeldungLbl);
    innerVL.addComponent(loginForm);
    innerVL.setComponentAlignment(loginForm, Alignment.TOP_CENTER);
    buttonLO = new HorDashLayout();
    buttonLO.setSpacing(true);
    loginBtn = new Button("login");
    buttonLO.addComponent(loginBtn);
    buttonLO.setComponentAlignment(loginBtn, Alignment.MIDDLE_LEFT);
    closeBtn = new Button("close window");
    buttonLO.addComponent(closeBtn);
    buttonLO.setComponentAlignment(closeBtn, Alignment.MIDDLE_RIGHT);
    loginForm.getFooter().addComponent(buttonLO);
    loginForm.getFooter().setMargin(true, true, true, true);

    innerVL2.addComponent(innerVL);
    innerVL2.setComponentAlignment(innerVL, Alignment.MIDDLE_CENTER);
    mainPnl.setContent(innerVL2);
    panelVL.addComponent(mainPnl);
    panelVL.setComponentAlignment(mainPnl, Alignment.MIDDLE_CENTER);
    mainVL.addComponent(panelVL);
    mainVL.setExpandRatio(panelVL, 10);
    setContent(mainVL);

    loginBtn.addListener(new Button.ClickListener()
    {
      @Override
      public void buttonClick(Button.ClickEvent event)
      {
        try
        {
          loginForm.commit();
        }
        catch (Exception e)
        {
        }
      }
    });
    loginBtn.setClickShortcut(KeyCode.ENTER);
    closeBtn.addListener(new Button.ClickListener()
    {
      @Override
      public void buttonClick(Button.ClickEvent event)
      {
        getApplication().getMainWindow().executeJavaScript("window.close();");
      }
    });
    loginForm.focus();
    loginForm.getField(FIELD_USERNAME).focus();
  }
}
